/* devices.h for msdos version 
 */

#include <io.h>
#define __REM_BIAS	128

#ifdef NO_REMOTE  

#ifdef ASPI
extern int aspiopen(char *, int, int);
extern int aspiread(int, char *, int);
extern int aspiwrite(int, char *, int);
extern int aspicreat(char *, int);
extern int aspiclose( int );
extern long aspilseek(int, long, int);
extern void aspiPhysRec(int);   /* forces SCSI record size */
extern void aspiDenCode(int);   /* forces SCSI tape density code */
#endif
#ifdef TCP
extern int do_rshd(char *, int, int);
extern int tcpopen(char *, int, int);
extern int tcpread (int,unsigned char *, int);
extern int tcpwrite(int,unsigned char *, int);
extern int tcpcreat(char *, int);
extern int tcpclose( int );
extern long tcplseek(int, long, int);
#endif
#ifdef DIO
extern  int dio_write(int drive,char *from_buf,unsigned int from_cnt);
extern  int dio_read(int drive,char *to_buf,unsigned int to_cnt);
extern  int dio_open_check(char *s);
extern  int dio_open2(char *p,int f);
extern  int dio_open3(char *p,int f,int m);
extern  int dio_close(int h);
extern  long dio_lseek(int h,long o,int r);
extern	void dio_str(char *s);
#endif
#define _isrmt(f)       0
#define rmtaccess	access
#define rmtstat		stat
#define rmtlstat	lstat
#define rmtioctl	ioctl
#define rmtdup		dup
#define rmtfstat	fstat
#define rmtfcntl	fcntl
#define rmtisatty	isatty

#else /* !NO_REMOTE */

#define RMTIOCTL

#ifndef O_CREAT
#define O_CREAT	01000
#endif

extern char *__rmt_path;

#if defined(STDC_HEADERS) || defined(HAVE_STRING_H)
#include <string.h>
#ifndef index
#define index strchr
#endif
#else
extern char *index ();
#endif

#define _remdev(path)	(!f_force_local && (__rmt_path=index(path, ':')))
#define _isrmt(fd)		((fd) >= __REM_BIAS)

#define rmtopen(path,oflag,mode) (_remdev(path) ? __rmt_open(path, oflag, mode, __REM_BIAS) : open(path, oflag, mode))
#define rmtaccess(path, amode)	(_remdev(path) ? 0 : access(path, amode))
#define rmtstat(path, buf)	(_remdev(path) ? (errno = EOPNOTSUPP), -1 : stat(path, buf))
#define rmtcreat(path, mode)	(_remdev(path) ? __rmt_open (path, 1 | O_CREAT, mode, __REM_BIAS) : creat(path, mode))
#define rmtlstat(path,buf)	(_remdev(path) ? (errno = EOPNOTSUPP), -1 : lstat(path,buf))

#define rmtread(fd, buf, n)	(_isrmt(fd) ? __rmt_read(fd - __REM_BIAS, buf, n) : read(fd, buf, n))
#define rmtwrite(fd, buf, n)	(_isrmt(fd) ? __rmt_write(fd - __REM_BIAS, buf, n) : write(fd, buf, n))
#define rmtlseek(fd, off, wh)	(_isrmt(fd) ? __rmt_lseek(fd - __REM_BIAS, off, wh) : lseek(fd, off, wh))
#define rmtclose(fd)		(_isrmt(fd) ? __rmt_close(fd - __REM_BIAS) : close(fd))
#ifdef RMTIOCTL
#define rmtioctl(fd,req,arg)	(_isrmt(fd) ? __rmt_ioctl(fd - __REM_BIAS, req, arg) : ioctl(fd, req, arg))
#else
#define rmtioctl(fd,req,arg)	(_isrmt(fd) ? (errno = EOPNOTSUPP), -1 : ioctl(fd, req, arg))
#endif
#define rmtdup(fd)		(_isrmt(fd) ? (errno = EOPNOTSUPP), -1 : dup(fd))
#define rmtfstat(fd, buf)	(_isrmt(fd) ? (errno = EOPNOTSUPP), -1 : fstat(fd, buf))
#define rmtfcntl(fd,cmd,arg)	(_isrmt(fd) ? (errno = EOPNOTSUPP), -1 : fcntl (fd, cmd, arg))
#define rmtisatty(fd)		(_isrmt(fd) ? 0 : isatty(fd))

#undef RMTIOCTL

int __rmt_open ();
int __rmt_close ();
int __rmt_read ();
int __rmt_write ();
long __rmt_lseek ();
int __rmt_ioctl ();
#endif /* !NO_REMOTE */


